#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_vip_config.h"
#include "FileEncrypt.h"
std::auto_ptr<M_vip_config> M_vip_config::msSingleton(nullptr);

int M_vip_config::GetCount()
{
	return (int)mMapData.size();
}

const M_vip_configData* M_vip_config::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_vip_configData>& M_vip_config::GetMapData()
{
	return mMapData;
}

void M_vip_config::Reload()
{
	mMapData.clear();
	Load();
}

void M_vip_config::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_vip_configData data;
		data.mID = element->IntAttribute("ID");
		data.mleve = element->IntAttribute("leve");
		data.mvipexp = element->IntAttribute("vipexp");
		{
			const char* everdayreward = element->Attribute("everdayreward");
			std::vector<std::string> veceverdayreward;
			boost::split(veceverdayreward, everdayreward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < veceverdayreward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(veceverdayreward[i].c_str(), &temp))
				{
					data.meverdayreward.push_back(temp);
				}
			}
		}
		data.mskillquantity = element->IntAttribute("skillquantity");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_vip_config::Load()
{
	Load("../Config/M_vip_config.xml");
}

M_vip_config* M_vip_config::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_vip_config());
	}
	return msSingleton.get();
}
